﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using NGinnBPM.Lib.Data;

namespace NGinnBPM.Lib.Messages
{
    /// <summary>
    /// Message to NGEnvironment
    /// to start a new process instance
    /// In response 'ProcessStartedMessage' message will be sent (or nothing, so plan for timeout)
    /// </summary>
    [Serializable]
    public class StartProcessMessage 
    {
        public string ProcessCorrelationId { get; set; }
        public string DefinitionId { get; set; }
        public Dictionary<string, object> InputData { get; set; }
        public string UserId { get; set; }
    }

    /// <summary>
    /// Response to 'startprocessmessage'
    /// </summary>
    [Serializable]
    public class ProcessStartedMessage
    {
        public string InstanceId { get; set; }
        public DateTime Timestamp { get; set; }
        public bool Success { get; set; }
    }

}
