﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using NGinnBPM.Lib.Data;

namespace NGinnBPM.Runtime.Messages
{

    /// <summary>
    /// Message used by external task instance to notify task logic handler
    /// that the task has been enabled
    /// Message handler should reply with ForceCompleteTaskMessage or FailTaskMessage or CancelTaskMessage.
    /// </summary>
    public class ExternalTaskEnabled
    {
        public ExternalTaskEnabled()
        {
            Timestamp = DateTime.Now;
        }

        public DateTime Timestamp { get; set; }
        public string InstanceId { get; set; }
        public string DefinitionId { get; set; }
        public string TaskId { get; set; }
        public Dictionary<string, object> TaskData { get; set; }
    }
}
