﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using NGinnBPM.Lib.Messages;

namespace NGinnBPM.Runtime.Messages
{
    /// <summary>
    /// Used as a general failure response delivered to a task instance.
    /// </summary>
    [Serializable]
    public class TaskInstanceFailure : TaskInstanceMessage, ICorrelatedMessage
    {
        public string CorrelationId { get; set; }
        public string ErrorInfo { get; set; }

        public TaskInstanceFailure()
        {
        }

        public TaskInstanceFailure(string instanceId, string errorInfo)
        {
            TargetTaskInstanceId = instanceId;
            ErrorInfo = errorInfo;
        }

        public TaskInstanceFailure(string instanceId, string correlationId, string errorInfo)
        {
            TargetTaskInstanceId = instanceId;
            CorrelationId = correlationId;
            ErrorInfo = errorInfo;
        }
    }
}
