﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace NGinnBPM.Services
{
    public interface IBarrierRegistry
    {
        void SetBarrier(string processDefId, string placeId, bool enable);
        bool GetBarrier(string processDefId, string placeId);
        IList<string> GetAllBarriers();
    }

    /// <summary>
    /// Notification that a barrier has been removed
    /// </summary>
    [Serializable]
    public class BarrierRemovedEvent
    {
        public string ProcessDefinitionId;
        public string PlaceId;
    }
}
