﻿using System;
using System.Collections.Generic;
using System.Text;
using NGinnBPM.Lib.Schema;
using NGinnBPM.Lib.Data;
using NGinnBPM.Runtime;
using NGinnBPM.Lib.Interfaces;

namespace NGinnBPM.Services
{
    /// <summary>
    /// Process script manager interface. Process script manager delivers
    /// script execution engine for evaluating script expressions in process
    /// and tasks. 
    /// </summary>
    public interface IProcessScriptManager
    {
        /// <summary>
        /// Notify process script manager that package definition has been updated.
        /// </summary>
        /// <param name="pd"></param>
        void PackageDefinitionUpdated(PackageDefinition pd);

        /// <summary>
        /// Verify correctness of scripts in a package.
        /// </summary>
        /// <param name="pd"></param>
        void VerifyPackageScripts(PackageDefinition pd);

        /// <summary>
        /// Return task script implementation
        /// </summary>
        /// <param name="pd"></param>
        /// <param name="taskId"></param>
        /// <returns></returns>
        ITaskScript GetTaskScript(ProcessDefinition pd, string taskId);

    }
}
