﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Text;
using Boo.Lang;
using NGinnBPM.Lib.Data;

namespace NGinnBPM.Services.Utilities
{
    public class DicWrap : IDynData
    {
        private IDictionary<string, object> _d;
        public DicWrap(IDictionary<string, object> d)
        {
            _d = d;
        }

        public ICollection<string> FieldNames
        {
            get { return _d.Keys; }
        }

        public object this[string idx]
        {
            get
            {
                object t;
                return _d.TryGetValue(idx, out t) ? t : null;
            }
            set
            {
                _d[idx] = value;
           }
        }
    }

    public class QuackDynWrapper : IQuackFu
    {
        private IDynData _dic;
        

        public QuackDynWrapper(IDynData dic)
        {
            _dic = dic;
        }

        #region IQuackFu Members

        public object QuackGet(string name, object[] parameters)
        {
            object v = _dic[name];
            if (parameters != null && parameters.Length > 0) throw new Exception("Indexers not supported");
            if (v is IDictionary)
            {
                return new QuackWrapper(v as IDictionary);
            }
            return v;
        }

        public object QuackInvoke(string name, params object[] args)
        {
            throw new NotImplementedException();
        }

        public object QuackSet(string name, object[] parameters, object value)
        {
            if (parameters != null && parameters.Length > 0) throw new Exception("Indexers not supported");
            _dic[name] = value;
            return value;
        }

        #endregion
    }

    public class QuackWrapper : IQuackFu
    {
        private IDictionary _dic;
        

        public QuackWrapper(IDictionary dic)
        {
            _dic = dic;
        }

        private QuackWrapper(IDictionary<string, object> dic)
        {
            _dic = new Hashtable();
            if (dic != null)
                foreach (string key in dic.Keys) _dic[key] = dic[key];
        }

        #region IQuackFu Members

        public object QuackGet(string name, object[] parameters)
        {
            object v = _dic[name];
            if (parameters != null && parameters.Length > 0) throw new Exception("Indexers not supported");
            if (v is IDictionary)
            {
                return new QuackWrapper(v as IDictionary);
            }
            return v;
        }

        public object QuackInvoke(string name, params object[] args)
        {
            throw new NotImplementedException();
        }

        public object QuackSet(string name, object[] parameters, object value)
        {
            if (parameters != null && parameters.Length > 0) throw new Exception("Indexers not supported");
            _dic[name] = value;
            return value;
        }

        #endregion
    }
}
