﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using NLog;
using Castle.Windsor;
using Castle.MicroKernel.Registration;

using System.ServiceModel;
using System.ServiceModel.Channels;
using System.ServiceModel.Description;
using NGinnBPM.Lib.Operations;
using System.IO;
using System.Xml;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Json;

namespace BasicTests
{
    class Program
    {
        private static Logger log = LogManager.GetCurrentClassLogger();
        static void Main(string[] args)
        {
            NLog.Config.SimpleConfigurator.ConfigureForConsoleLogging(LogLevel.Debug);
            try
            {
                SerializationTest.Test1();
                //WDZTest();
                //DataObjectTests.TestSerialization();
                //DataObjectTests.TestJint();
                //SSHost();
               // WCFHost();
               // DataContractTest();
            }
            catch (Exception ex)
            {
                log.Error("Error: {0}", ex);
                Console.ReadLine();
            }
        }

        static void DataContractTest()
        {
            var kt = new Type[] { typeof(int), typeof(string) };
            var ser = new System.Runtime.Serialization.DataContractSerializer(typeof(TestOperation), kt);
            
            TestOperation to = new TestOperation();
            to.Data = new List<DataField>();
            to.Data.Add(new DataField { Name = "ala", Val = 342 });
            to.Data.Add(new DataField { Name = "bala", Val = "kotek" });
            to.Data.Add(new DataField { Name = "kot", Val = new DataField[] { 
                new DataField { Name = "a", Val=true },
                new DataField { Name = "b", Val=883.43},
                new DataField { Name = "date", Val=DateTime.Now},
                new DataField { Name = "l", Val= new int[] {1,2,3,4,5}}
            } });
            var sw = new StringWriter();
            var xw = XmlWriter.Create(sw);

            ser.WriteObject(xw, to);
            xw.Flush();
            Console.WriteLine("ser: {0}", sw);

            var to2 = ser.ReadObject(XmlReader.Create(new StringReader(sw.ToString())));

            System.Runtime.Serialization.Json.DataContractJsonSerializer ser2 = new System.Runtime.Serialization.Json.DataContractJsonSerializer(typeof(TestOperation));
            var ms = new MemoryStream();
            ser2.WriteObject(ms, to);
            ms.Seek(0, SeekOrigin.Begin);
            Console.WriteLine("ser2: {0}", new StreamReader(ms).ReadToEnd());

            var d1 = new Dictionary<string, object>();
            d1["ala"] = "kot";
            d1["dee"] = DateTime.Now;
            var d2 = new Dictionary<string, object>();
            d2["intds"] = new int[] { 1, 2, 3, 3, 4, 5 };
            d2["ee"] = 323.4;
            d1["d2"] = d2;

            var sp = Ser.V.Wrap(d1);
            var ser3 = new DataContractSerializer(typeof(Ser.V));
            ms.Seek(0, SeekOrigin.Begin);
            ser3.WriteObject(ms, sp);
            ms.Seek(0, SeekOrigin.Begin);
            Console.WriteLine("ser3: {0}", new StreamReader(ms).ReadToEnd());

            var ser4 = new DataContractJsonSerializer(typeof(Ser.V));
            ms.Seek(0, SeekOrigin.Begin);
            ser4.WriteObject(ms, sp);
            ms.Seek(0, SeekOrigin.Begin);
            Console.WriteLine("ser4: {0}", new StreamReader(ms).ReadToEnd());

        }

        static void WDZTest()
        {
            wsdl_trad.Proc2 p2 = new wsdl_trad.Proc2();
            string ret = p2.StartProcess(new wsdl_trad.Task_WDZ_4_InputData { DocumentId = "93828934234" }, "me", "corr-id", "parent-task");

            WDZ.Proc2SoapClient cli = new WDZ.Proc2SoapClient();
            string inst = cli.StartProcess(new WDZ.Task_WDZ_4_InputData { DocumentId = "32892323" }, "me", null, null);

        }

        
        static void WCFHost()
        {
            var srvUrl = "http://localhost:9091/wstest";

            /*ServiceHost serviceHost = new ServiceHost(typeof(TestService), new Uri(srvUrl));
            serviceHost.AddServiceEndpoint(typeof(ITestService), new BasicHttpBinding(), "");
            var se = serviceHost.AddServiceEndpoint(typeof(ITestService), new WebHttpBinding(), "json");
            se.Behaviors.Add(new WebHttpBehavior { HelpEnabled = true });

            System.ServiceModel.Description.ServiceMetadataBehavior smb = new System.ServiceModel.Description.ServiceMetadataBehavior();
            smb.HttpGetEnabled = true;
            smb.HttpGetUrl = new Uri(srvUrl);
            serviceHost.Description.Behaviors.Add(smb);
            
            

            serviceHost.Open();

            Console.WriteLine("This console application hosts the MyFirstService WCF service");
            Console.WriteLine(string.Format("The service is available at address: {0}", srvUrl));
            Console.WriteLine("Press ENTER to finish hosting");
            Console.ReadLine();

            serviceHost.Close();
             * */
        }
    }
}
